#include <stdio.h>
#include <stdlib.h>
#include <sndfile.h>
#include <math.h>
#include <time.h>

#include    "sound.h"
#include    "functions.h"
#include    "basics.h"
#include    "options.h"

int main(int argc, char **argv)
{

const char
    * inSound = NULL,
    * outSoundDegraded=NULL,
    * outSoundRestored=NULL,
    * outASCIIRestored=NULL,
    * outASCIIBursts;	

char outASCIIRestoredBurst[1000];


int nBursts,nMax;

sOptions *O;

int p,nWindow, nIter, i,j,k,nBurstsPlot;

Sound 	* S_in=NULL,
	* S_out=NULL;

int * burst=NULL;
double 	SNR=0,
	value_signal=0,
	value_noise=0;

int *	start_burst=NULL,
    *	end_burst=NULL,
    *   plot_burst=NULL;

double * min_burst=NULL,
       * max_burst=NULL;

FILE *f1=NULL,
     *f2=NULL;

  inSound = argc > 1 ? argv[1] : NULL;
  if (inSound == NULL) return -1;
  O = newOptions(argv + 1, argc-1);

  outSoundDegraded = getStringOption(O, "outSoundDegraded", NULL);
  outSoundRestored = getStringOption(O, "outSoundRestored", NULL);
  outASCIIRestored = getStringOption(O, "outASCIIRestored", NULL);
  outASCIIBursts = getStringOption(O, "outASCIIBursts", NULL);
  
   nBursts    = getIntOption(O, "nBursts",   200);
   nMax    = getIntOption(O, "nMax",   100);
   p    = getIntOption(O, "p",   302);
   nWindow    = getIntOption(O, "nWindow",   2416);
   nBurstsPlot    = getIntOption(O, "nBurstsPlot",   20);	

    nIter=2;
    
    srand (time (NULL));
        
    S_in=audioRead(inSound,1,20000000);
    

    S_out=audioRead(inSound,1,20000000);	
    burst=zeros_ivect(S_out->nSamples);
    generate_degradation(S_out,burst,nBursts,nMax,p);
    if (outSoundDegraded)
    audioWrite(S_out,outSoundDegraded);


    initialization(S_out,burst);
    i=0;
    for (i=0;i<nIter;i++) {
    reconstruct_signal(S_out,burst,nWindow,p);
    }
    if (outSoundRestored)
    audioWrite(S_out,outSoundRestored);


	    

	for (i=0;i<S_in->nSamples;i++) {
		if (burst[i]==1) {
            	value_signal+=S_in->channel[0][i]*(S_in->channel[0][i]);
            	value_noise+=(S_in->channel[0][i]-S_out->channel[0][i])*(S_in->channel[0][i]-S_out->channel[0][i]);
        	}
    	    }
    	   SNR=(10*log(value_signal)-10*log(value_noise))/log(10);






    if (outASCIIRestored) {

        j=0;
    	start_burst=zeros_ivect(nBursts);
    	for (i=1;i<S_in->nSamples;i++){
		if ((burst[i]==1) && (burst[i-1]==0)){
			start_burst[j]=i;
			j++;
		}
    	}
    	
    	j=0;
    	end_burst=zeros_ivect(nBursts);	
    	for (i=1;i<S_in->nSamples;i++){
		if ((burst[i]==0) && (burst[i-1]==1)){
			end_burst[j]=i-1;
			j++;
		}
    	}
	
	if (nBurstsPlot>nBursts)
	nBurstsPlot=nBursts;
	
	rand_unique(0,nBursts-1,nBurstsPlot,&plot_burst);
	isort(plot_burst, nBurstsPlot);


	/*print_ivect(plot_burst,nBurstsPlot);*/


	
	for (j=0;j<nBurstsPlot;j++) {
	sprintf(outASCIIRestoredBurst,"%s_%d.asc",outASCIIRestored,j);
	f1 = fopen(outASCIIRestoredBurst,"w");
	k=end_burst[plot_burst[j]]-start_burst[plot_burst[j]]+1;
	
		for (i=start_burst[plot_burst[j]]-k;i<end_burst[plot_burst[j]]+k+1; i++) {
			if ((i>=start_burst[plot_burst[j]])&(i<=end_burst[plot_burst[j]])){
    		fprintf(f1, "%6d %6d %12.7g %12.7g\n", i+1-start_burst[plot_burst[j]]+k,i+1-start_burst[plot_burst[j]]+k,S_out->channel[0][i],S_in->channel[0][i]); }
			else {
		fprintf(f1, "%6d %6d %12.7g %12.7g\n", i+1-start_burst[plot_burst[j]]+k,i+1-start_burst[plot_burst[j]]+k,S_in->channel[0][i],S_in->channel[0][i]);}
    	}
    	fclose(f1);
	}



	min_burst=zeros_dvect(nBurstsPlot);
	max_burst=zeros_dvect(nBurstsPlot);
	for (i=0;i<nBurstsPlot;i++){
	    k=end_burst[plot_burst[i]]-start_burst[plot_burst[i]]+1;
		for (j=start_burst[plot_burst[i]]-k;j<end_burst[plot_burst[i]]+k+1;j++) {
			if (floor(S_out->channel[0][j]*100)/100<min_burst[i])
			min_burst[i]=floor(S_out->channel[0][j]*100)/100;

			if (floor(S_in->channel[0][j]*100)/100<min_burst[i])
			min_burst[i]=floor(S_in->channel[0][j]*100)/100;

			if (ceil(S_out->channel[0][j]*100)/100>max_burst[i])
			max_burst[i]=ceil(S_out->channel[0][j]*100)/100;

			if (ceil(S_in->channel[0][j]*100)/100>max_burst[i])
			max_burst[i]=ceil(S_in->channel[0][j]*100)/100;
		}
	}


    	f2 = fopen(outASCIIBursts, "w");
    	for (i=0; i<nBurstsPlot; i++) {
		k=end_burst[plot_burst[i]]-start_burst[plot_burst[i]]+1;
    		fprintf(f2, "1 %6d %.2f %.2f %d %d\n",end_burst[plot_burst[i]]+2*k-start_burst[plot_burst[i]]+1,min_burst[i],max_burst[i],plot_burst[i]+1,k);
		}
    	fclose(f2);





	




	
    }
    


    printf("1 %ld %d %d %d %d %.2f %d",S_in->nSamples,nBursts,nMax,p,nWindow,SNR,nBurstsPlot);


   soundClean(S_in);
   soundClean(S_out);
   free(burst);
   free(start_burst);
   free(max_burst);
   free(min_burst);
   free(end_burst);
   deleteOptions(O);

    return 0;




}
